#=== darch ġ  darch  ===#
install.packages("devtools")
library(devtools)
install_github("maddin79/darch@v0.12.0")
library(darch)                         

#=== ڷ ҷ ===#
hyperurl <-'http://archive.ics.uci.edu/ml/machine-learning-databases/thyroid-disease/hypothyroid.data'
names <- c('target', 'age', 'sex', 'on_thyroxine', 'query_on_thyroxine', 
           'on_antithyroid_medication', 'thyroid_surgery', 'query_hypothyroid',
           'query_hyperthyroid', 'pregnant', 'sick', 'tumor', 'lithium', 'goitre',  
           'TSH_measured', 'TSH', 'T3_measured', 'T3', 'TT4_measured', 'TT4', 
           'T4U_measured', 'T4U', 'FTI_measured', 'FTI', 'TBG_measured', 'TBG')
hyper <- read.table(hyperurl, header=F, sep =',', col.names=names)

#=== ڷ ó ===#  
hyper$target <- ifelse(hyper$target=='negative',0,1)
ind <- sapply(hyper, is.factor)
hyper[ind] <- lapply(hyper[ind], as.character)
hyper[ hyper == "?" ] = NA
hyper[ hyper == "f" ] = 0
hyper[ hyper == "t" ] = 1
hyper[ hyper == "n" ] = 0
hyper[ hyper == "y" ] = 1
hyper[ hyper == "M" ] = 0
hyper[ hyper == "F" ] = 1
hyper[ind] <- lapply(hyper[ind], as.numeric)
repalceNAsWithMean <- function(x) {replace(x, is.na(x), mean(x[!is.na(x)]))}
hyper <- repalceNAsWithMean(hyper)

#=== Ʒڷ ڷ  ===#
set.seed(20180202)
n1 <- table(hyper$target)[1]  
n2 <- table(hyper$target)[2]  
ind1 <- sample(which(hyper$target==0), round(n1/2), replace=F)
ind2 <- sample(which(hyper$target==1), round(n2/2), replace=F)
tr_ind <- c(ind1,ind2)
hyper_tr <- hyper[tr_ind,]
hyper_te <- hyper[-tr_ind,]
hyper_tr$target <- as.factor(hyper_tr$target)
hyper_te$target <- as.factor(hyper_te$target)

#===  Ͽ  Ű нϱ ===#
# darch RBM Ͽ н ϰ  ˰ Ǵ 
# Rprop Ͽ Ѵ
darch_fit <- darch(hyper_tr[,2:26], hyper_tr[,1], rbm.numEpochs = 100,
                   rbm.batchSize = 2, rbm.lastLayer = F, 
                   layers = c(25,19,18,10,1), 
                   # Է, 1, 2, 3      
                   darch.fineTuneFunction = rpropagation, rprop.method = "iRprop+",
                   darch.batchSize = 2, retainData = F, darch.numEpochs = 100)

#=== н  Ű Ͽ ϱ ===#
y_pred <- predict(darch_fit, newdata=hyper_te[,2:26], type="class")
mean(y_pred != hyper_te[,1])  #ڷῡ  з 
#[]
#0.04743833
table(hyper_te[,1], y_pred, dnn=c("Observed","Predicted"))
#[]
#         Predicted
#Observed    0    1
#        0 1506   0
#        1   75   0 